<template>
	<main>
		<div class="cards">
			<h1>Einstellungen</h1>
			<form v-on:submit.prevent>
				<div class="card-body cols c-0-1 mobile-flex">
					<div class="cell c-merged">
						<strong>HINWEIS:</strong>
						<p>Damit die &Auml;nderung Deines Namens f&uuml;r Dich auch im Men&uuml; sichtbar wird, erfordert es einen erneuten Login.</p>
						<strong>UPDATE:</strong>
						<p>Du wirst nach &Auml;nderung Deines Namens automatisch ausgelogged, da mir die Zeit fehlt, mich mit der notwendigen JWT Manipulation zu befassen.</p>
					</div>
					<div class="cell">User Name:</div>
					<div class="cell">
						<input ref="userName" v-model="form.userName" type="text" class="input" />
					</div>
					<div class="cell c-merged">
						<button @click="updateUser" class="button">Speichern</button>
					</div>
				</div>
			</form>
		</div>

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />

		<loader v-if="isLoading" />
	</main>
</template>

<script>
import Loader from "@/components/Loader"
import SystemMessage from "@/components/SystemMessage";
export default {
	name: "UserSettings",
	title: "Einstellungen",
	components: {
		Loader,
		SystemMessage
	},
	data: () => ({
		isLoading: false,
		sysMsg: undefined,
		form: {
			userName: ""
		}
	}),

	methods: {
		async updateUser() {
			this.sysMsg = "";

			if(!this.globalValidateForm()) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}

			if (this.form.userName === this.userName) {
				this.sysMsg = "Keine Aenderungen vorgenommen!";
				return;
			}

			this.isLoading = true
			try {
				let userDTO = {
					id: this.userID,
					name: this.form.userName
				}
				const response = await this.$http.put("/api/user/update", userDTO)
				switch (response.status) {
					case 200:
						this.isLoading = false
						this.sysMsg = "Erfolgreich upgedated. Sie werden nun ausgelogged.";
						await this.$store.dispatch("logout");
						setTimeout(() => this.$router.push("/home"), 2000);
						break;
					case 204:
						this.sysMsg = "Fehlende Eingaben!";
						break;
					case 400:
						this.sysMsg = "Interner Fehler!";
						break;
					case 404:
						this.sysMsg = "User ID nicht gefunden. Bitte melden Sie sich erneut an.";
						break;
				}
			} catch (e) {
				console.error(e);
			}
			this.isLoading = false;
		}
	},

	computed: {
		userName() {
			return this.$store.getters.getUserName;
		},
		userID() {
			return this.$store.getters.getUserId;
		}
	},
	mounted() {
		this.form.userName = this.userName;
	}
}
</script>

<style scoped>

</style>